3. Building and installing a package
Prev |  | Next

## 3. Building and installing a package

After you've unpacked a Cabal package, you can build it by moving into the root directory of the package and using the `Setup.hs` or `Setup.lhs` script there:

`runhaskell Setup.hs` [`command`] [`option`...]

where `runhaskell` might be runhugs, runghc or runnhc. The `command` argument selects a particular step in the build/install process. You can also get a summary of the command syntax with

`runhaskell Setup.hs `--help``

Example 5. Building and installing a system package

    runhaskell Setup.hs configure --ghc
    runhaskell Setup.hs build
    runhaskell Setup.hs install

The first line readies the system to build the tool using GHC; for example, it checks that GHC exists on the system. The second line performs the actual building, while the last both copies the build results to some permanent place and registers the package with GHC.

Example 6. Building and installing a user package

    runhaskell Setup.hs configure --ghc --user --prefix=$HOME
    runhaskell Setup.hs build
    runhaskell Setup.hs install

The package may use packages from the user's package database as well as the global one (`--user`), is installed under the user's home directory (`--prefix`), and is registered in the user's package database (`--user`).

Example 7. Creating a binary package

When creating binary packages (e.g. for RedHat or Debian) one needs to create a tarball that can be sent to another system for unpacking in the root directory:

    runhaskell Setup.hs configure --ghc --prefix=/usr
    runhaskell Setup.hs build
    runhaskell Setup.hs copy --destdir=/tmp/mypkg
    (cd /tmp/mypkg; tar cf - .) | gzip -9 >mypkg.tar.gz

If the package contains a library, you need two additional steps:

    runhaskell Setup.hs register --gen-script
    runhaskell Setup.hs unregister --gen-script

This creates shell scripts `register.sh` and `unregister.sh`, which must also be sent to the target system. After unpacking there, the package must be registered by running the `register.sh` script. The `unregister.sh` script would be used in the uninstall procedure of the package. Similar steps may be used for creating binary packages for Windows.

The following options are understood by all commands:

`--help`, `-h` or `-?`

  List the available options for the command.

`--verbose`=`n` or `-v` `n`

  Set the verbosity level (0-5). The normal level is 1; a missing `n` defaults to 3.

The various commands and the additional options they support are described below. In the simple build infrastructure, any other options will be reported as errors, except in the case of the `configure` command.

### 3.1. setup configure

Prepare to build the package. Typically, this step checks that the target platform is capable of building the package, and discovers platform-specific features that are needed during the build.

The user may also adjust the behaviour of later stages using the options listed in the following subsections. In the simple build infrastructure, the values supplied via these options are recorded in a private file read by later stages.

If a user-supplied `configure` script is run (see Section 2.3, “System-dependent parameters” or Section 2.4, “More complex packages”), it is passed the `--with-hc-pkg`, `--prefix`, `--bindir`, `--libdir`, `--datadir` and `--libexecdir` options, plus any unrecognized options. In addition the value of the `--with-compiler` option is passed in a `--with-hc` option.

#### 3.1.1. Programs used for building

The following options govern the programs used to process the source files of a package:

`--ghc` or `-g`, `--nhc` or `-n`, `--hugs`

  Specify which Haskell implementation to use to build the package. At most one of these flags may be given. If none is given, the implementation under which the setup script was compiled or interpreted is used.

`--with-compiler`=`path` or `-w` `path`

  Specify the path to a particular compiler. If given, this must match the implementation selected above. The default is to search for the usual name of the selected implementation.

  This flag also sets the default value of the `--with-hc-pkg` option to the package tool for this compiler. Check the output of `setup configure` to ensure that it finds the right package tool (or use `--with-hc-pkg` explicitly).

`--with-hc-pkg`=`path`

  Specify the path to the package tool, e.g. ghc-pkg. The package tool must be compatible with the compiler specified by `--with-compiler`. If this option is omitted, the default value is determined from the compiler selected.

`--with-haddock`=`path`

  Specify the path to haddock.

`--with-happy`=`path`

  Specify the path to happy.

`--with-alex`=`path`

  Specify the path to alex.

`--with-hsc2hs`=`path`

  Specify the path to hsc2hs.

`--with-c2hs`=`path`

  Specify the path to c2hs.

`--with-greencard`=`path`

  Specify the path to greencard.

`--with-cpphs`=`path`

  Specify the path to cpphs.

#### 3.1.2. Installation paths

The following options govern the location of installed files from a package:

`--prefix`=`dir`

  The root of the installation, for example `/usr/local` on a Unix system, or `C:\Program Files` on a Windows system. The other installation paths are usually subdirectories of `prefix`, but they don't have to be.

`--bindir`=`dir`

  Executables that the user might invoke are installed here.

`--libdir`=`dir`

  Object-code libraries are installed here.

`--libsubdir`=`dir`

  A subdirectory of `libdir` in which libraries are actually installed. For example, in the simple build system on Unix, the default `libdir` is `/usr/local/lib`, and `libsubdir` contains the package identifier and compiler, e.g. `mypkg-0.2/ghc-6.4`, so libraries would be installed in `/usr/local/lib/mypkg-0.2/ghc-6.4`.

  Not all build systems make use of `libsubdir`, in particular the Distribution.Make system does not.

`--datadir`=`dir`

  Architecture-independent data files are installed here.

`--datasubdir`=`dir`

  A subdirectory of `datadir` in which data files are actually installed. This option is similar to `--libsubdir` in that not all build systems make use of it.

`--libexecdir`=`dir`

  Executables that are not expected to be invoked directly by the user are installed here.

##### 3.1.2.1. Paths in the simple build system

For the simple build system, the following defaults apply:

Option | Windows Default | Unix Default
--- | --- | ---
`--prefix` | `C:\Program Files` | `/usr/local`
`--bindir` | `$prefix\Haskell\bin` | `$prefix/bin`
`--libdir` | `$prefix\Haskell` | `$prefix/lib`
`--libsubdir` (Hugs) | `hugs\packages\$pkg` | `hugs/packages/$pkg`
`--libsubdir` (others) | `$pkgid\$compiler` | `$pkgid/$compiler`
`--datadir` (executable) | `$prefix\Haskell` | `$prefix/share`
`--datadir` (library) | `C:\Program Files\Common Files` | `$prefix/share`
`--datasubdir` | `$pkgid` | `$pkgid`
`--libexecdir` | `$prefix\$pkgid` | `$prefix/libexec`

The following strings are substituted into directory names:

`$prefix`

  The value of `prefix`

`$pkgid`

  The full package identifier, e.g. `pkg-0.1`

`$compiler`

  The compiler and version, e.g. `ghc-6.4.1`

`$pkg`

  The name of the package only

`$version`

  The version of the package

##### 3.1.2.2. Prefix-independence

On Windows (and perhaps other OSs), it is possible to query the pathname of the running binary. This means that we can construct an installable executable package that is independent of its absolute install location. The executable can find its auxiliary files by finding its own path and knowing the location of the other files relative to `bindir`. Prefix-independence is particularly useful: it means the user can choose the install location (i.e. the value of `prefix`) at install-time, rather than having to bake the path into the binary when it is built.

In order to achieve this, we require that for an executable on Windows, all of `bindir`, `libdir`, `datadir` and `libexecdir` begin with `$prefix`. If this is not the case then the compiled executable will have baked in all absolute paths.

The application need do nothing special to achieve prefix-independence. If it finds any files using `getDataFileName` and the other functions provided for the purpose (see Section 2.2, “Accessing data files from package code”), the files will be accessed relative to the location of the current executable.

A library cannot (currently) be prefix-independent, because it will be linked into an executable whose filesystem location bears no relation to the library package.

#### 3.1.3. Miscellaneous options

`--user`

  Allow dependencies to be satisfied by the user package database, in addition to the global database.

  This also implies a default of `--user` for any subsequent `install` command, as packages registered in the global database should not depend on packages registered in a user's database.

`--global`

  (default) Dependencies must be satisfied by the global package database.

`--enable-library-profiling` or `-p`

  Request that an additional version of the library with profiling features enabled be built and installed (only for implementations that support profiling).

`--disable-library-profiling`

  (default) Do not generate an additional profiling version of the library.

`--enable-executable-profiling`

  Any executables generated should have profiling enabled (only for implementations that support profiling). For this to work, all libraries used by these executables must also have been built with profiling support.

`--disable-executable-profiling`

  (default) Do not enable profiling in generated executables.

In the simple build infrastructure, an additional option is recognized:

`--scratchdir`=`dir` or `-b` `dir`

  Specify the directory into which the package will be built (default: `dist/build`).

### 3.2. setup build

Perform any preprocessing or compilation needed to make this package ready for installation.

### 3.3. setup haddock

Build the interface documentation for a library using haddock.

This command takes the following option:

`--hoogle`

  Generate a file `dist/doc/html/`pkgid`.txt`, which can be converted by Hoogle into a database for searching. This is equivalent to running haddock with the `--hoogle` flag.

### 3.4. setup install

Copy the files into the install locations and (for library packages) register the package with the compiler, i.e. make the modules it contains available to programs.

The install locations are determined by options to `setup configure` (see Section 3.1.2, “Installation paths”).

This command takes the following options:

`--global`

  Register this package in the system-wide database. (This is the default, unless the `--user` option was supplied to the `configure` command.)

`--user`

  Register this package in the user's local package database. (This is the default if the `--user` option was supplied to the `configure` command.)

### 3.5. setup copy

Copy the files without registering them. This command is mainly of use to those creating binary packages.

This command takes the following option:

`--destdir`=`path`

  Specify the directory under which to place installed files. If this is not given, then the root directory is assumed.

### 3.6. setup register

Register this package with the compiler, i.e. make the modules it contains available to programs. This only makes sense for library packages. Note that the `install` command incorporates this action. The main use of this separate command is in the post-installation step for a binary package.

This command takes the following options:

`--global`

  Register this package in the system-wide database. (This is the default.)

`--user`

  Register this package in the user's local package database.

`--gen-script`

  Instead of registering the package, generate a script containing commands to perform the registration. On Unix, this file is called `register.sh`, on Windows, `register.bat`. This script might be included in a binary bundle, to be run after the bundle is unpacked on the target system.

`--inplace`

  Registers the package for use directly from the build tree, without needing to install it. This can be useful for testing: there's no need to install the package after modifying it, just recompile and test.

  This flag does not create a build-tree-local package database. It still registers the package in one of the user or global databases.

  However, there are some caveats. It only works with GHC (currently). It only works if your package doesn't depend on having any supplemental files installed - plain Haskell libraries should be fine.

`--with-hc-pkg`=`path`

  Specify the path to the package tool, e.g. ghc-pkg. This overrides the `hc-pkg` tool discovered during configure.

### 3.7. setup unregister

Deregister this package with the compiler.

This command takes the following options:

`--global`

  Deregister this package in the system-wide database. (This is the default.)

`--user`

  Deregister this package in the user's local package database.

`--gen-script`

  Instead of deregistering the package, generate a script containing commands to perform the deregistration. On Unix, this file is called `unregister.sh`, on Windows, `unregister.bat`. This script might be included in a binary bundle, to be run on the target system.

### 3.8. setup clean

Remove any local files created during the `configure`, `build`, `haddock`, `register` or `unregister` steps, and also any files and directories listed in the `extra-tmp-files` field.

### 3.9. setup test

Run the test suite specified by the `runTests` field of `Distribution.Simple.UserHooks`. See Distribution.Simple for information about creating hooks and using `defaultMainWithHooks`.

### 3.10. setup sdist

Create a system- and compiler-independent source distribution in a file ``package`-`version`.tar.gz` in the `dist` subdirectory, for distribution to package builders. When unpacked, the commands listed in this section will be available.

The files placed in this distribution are the package description file, the setup script, the sources of the modules named in the package description file, and files named in the `license-file`, `main-is`, `c-sources`, `data-files` and `extra-source-files` fields.

This command takes the following option:

`--snapshot`

  Append today's date (in `YYYYMMDD` form) to the version number for the generated source package. The original package is unaffected.

Prev |  | Next
2. Creating a package | Home | 4. Known bugs and deficiencies